## mingw-w64-dlib-19.24.4-1.src.tar.zst

=== dlib/test/CMakeLists.txt ===
#
# This is a CMake makefile.  You can find the cmake utility and
# information about it at http://www.cmake.org
#

cmake_minimum_required(VERSION 3.8.0)

# create a variable called target_name and set it to the string "dtest"
set (target_name dtest)
PROJECT(${target_name})

# compile the dlib/all/source.cpp file into its own object just to make sure it compiles
set(DLIB_TEST_COMPILE_ALL_SOURCE_CPP ON)

add_subdirectory(.. dlib_build)

add_executable(${target_name} main.cpp tester.cpp
   example.cpp
   active_learning.cpp
   any.cpp
   any_function.cpp
   array2d.cpp
   array.cpp
   assignment_learning.cpp
   base64.cpp
   bayes_nets.cpp
   bigint.cpp
   binary_search_tree_kernel_1a.cpp
   binary_search_tree_kernel_2a.cpp
   binary_search_tree_mm1.cpp
   binary_search_tree_mm2.cpp
   bridge.cpp
   bsp.cpp
   byte_orderer.cpp
   cca.cpp
   clustering.cpp
   cmd_line_parser.cpp
   cmd_line_parser_wchar_t.cpp
   compress_stream.cpp
   conditioning_class_c.cpp
   conditioning_class.cpp
   config_reader.cpp
   constexpr_if.cpp
   correlation_tracker.cpp
   crc32.cpp
   create_iris_datafile.cpp
   data_io.cpp
   directed_graph.cpp
   discriminant_pca.cpp
   disjoint_subsets.cpp
   disjoint_subsets_sized.cpp
   ekm_and_lisf.cpp
   empirical_kernel_map.cpp
   entropy_coder.cpp
   entropy_encoder_model.cpp
   example_args.cpp
   face.cpp
   fft.cpp
   fhog.cpp
   filtering.cpp
   find_max_factor_graph_nmplp.cpp
   find_max_factor_graph_viterbi.cpp
   geometry.cpp
   graph.cpp
   graph_cuts.cpp
   graph_labeler.cpp
   hash.cpp
   hash_map.cpp
   hash_set.cpp
   hash_table.cpp
   hog_image.cpp
   image.cpp
   invoke.cpp
   iosockstream.cpp
   is_same_object.cpp
   isotonic_regression.cpp
   kcentroid.cpp
   kernel_matrix.cpp
   kmeans.cpp
   learning_to_track.cpp
   least_squares.cpp
   linear_manifold_regularizer.cpp
   lspi.cpp
   lz77_buffer.cpp
   map.cpp
   math.cpp
   matrix2.cpp
   matrix3.cpp
   matrix4.cpp
   matrix_chol.cpp
   matrix.cpp
   matrix_eig.cpp
   matrix_lu.cpp
   matrix_qr.cpp
   max_cost_assignment.cpp
   max_sum_submatrix.cpp
   md5.cpp
   member_function_pointer.cpp
   metaprogramming.cpp
   mpc.cpp
   multithreaded_object.cpp
   numerical_integration.cpp
   object_detector.cpp
   oca.cpp
   one_vs_all_trainer.cpp
   one_vs_one_trainer.cpp
   optimization.cpp
   optimization_test_functions.cpp
   global_optimization.cpp
   opt_qp_solver.cpp
   parallel_for.cpp
   parse.cpp
   pipe.cpp
   pixel.cpp
   probabilistic.cpp
   pyramid_down.cpp
   queue.cpp
   rand.cpp
   ranking.cpp
   read_write_mutex.cpp
   reference_counter.cpp
   rls.cpp
   random_forest.cpp
   sammon.cpp
   scan_image.cpp
   sequence.cpp
   sequence_labeler.cpp
   sequence_segmenter.cpp
   serialize.cpp
   set.cpp
   sldf.cpp
   sliding_buffer.cpp
   sockets2.cpp
   sockets.cpp
   sockstreambuf.cpp
   sparse_vector.cpp
   stack.cpp
   static_map.cpp
   static_set.cpp
   statistics.cpp
   std_vector_c.cpp
   string.cpp
   svm_c_linear.cpp
   svm_c_linear_dcd.cpp
   svm.cpp
   svm_multiclass_linear.cpp
   svm_struct.cpp
   svr_linear_trainer.cpp
   symmetric_matrix_cache.cpp
   thread_pool.cpp
   threads.cpp
   timer.cpp
   tokenizer.cpp
   trust_region.cpp
   tuple.cpp
   type_safe_union.cpp
   vectorstream.cpp
   dnn.cpp
   cublas.cpp
   find_optimal_parameters.cpp
   elastic_net.cpp
   te.cpp
   ffmpeg.cpp
   optional.cpp
   scope.cpp
)

get_filename_component(DLIB_FFMPEG_DATA ${CMAKE_SOURCE_DIR}/ffmpeg_data/details.cfg REALPATH)
target_compile_definitions(${target_name} PRIVATE DLIB_FFMPEG_DATA="${DLIB_FFMPEG_DATA}")

if (CMAKE_COMPILER_IS_GNUCXX)
   # Turn on all warnings, and treat them as errors.
   add_compile_options(-W -Wall -Wextra -Wpedantic -Werror)
   add_compile_options(-fdiagnostics-color=always)
   # I don't care about unused testing functions though.  I like to keep them
   # around.  Don't warn about it.
   add_compile_options(-Wno-unused-function)
   add_compile_options(-Wno-strict-overflow)
   add_compile_options(-Wno-maybe-uninitialized)

   if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 11.3.0 AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS_EQUAL 11.4.0)
      # These versions of gcc wrongly yield this warning:
      #  dlib::row_major_layout::layout<double, 0, 2, dlib::memory_manager_stateless_kernel_1<char> >::data’ with nonzero offset 8 [-Werror=free-nonheap-object]
      #   61 |                 delete [] item;
      # Which by inspection of the dlib::row_major_layout::layout class you can see is clearly incorrect, as `data` is most
      # definitely heap allocated.
      add_compile_options(-Wno-free-nonheap-object)
   endif()

   if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.13.0") 
      # strip debug symbols to make the binary smaller
      target_link_options(${target_name} PRIVATE $<$<CONFIG:RELEASE>:-s>)
   endif()

elseif (MSVC)
   # Treat warnings as errors.
   add_compile_options(/WX)
else() # basically Clang
   # Treat warnings as errors, but do not turn on all warnings.
   add_compile_options(-W -Werror)
   # This is for the comment in face_detection_ex.cpp that says "faces/*.jpg"
   add_compile_options(-Wno-comment)

   if(${CMAKE_VERSION} VERSION_GREATER "3.8.0") 
      # strip debug symbols to make the binary smaller
      target_link_options(${target_name} PRIVATE $<$<CONFIG:RELEASE>:-s>)
   endif()
endif()


target_link_libraries(${target_name} dlib::dlib )


if (NOT DLIB_NO_GUI_SUPPORT)
   add_subdirectory(gui)
   add_subdirectory(tools)

   if (CMAKE_COMPILER_IS_GNUCXX)
      # The tutorials set some variables that are not used.
      add_definitions("-Wno-unused-but-set-variable")
   endif()

   add_subdirectory(examples)
endif()

=== dlib/external/cblas/CMakeLists.txt ===
#
# This is a CMake makefile.  You can find the cmake utility and
# information about it at http://www.cmake.org
#


cmake_minimum_required(VERSION 3.8.0)
project(cblas)


enable_language (Fortran)

set(CMAKE_POSITION_INDEPENDENT_CODE True)
add_definitions(-DADD_ -DF77_INT=ptrdiff_t)

add_library(cblas STATIC 
   cblas_caxpy.c
   #cblas_ccopy.c
   cblas_cdotc_sub.c
   cblas_cdotu_sub.c
   #cblas_cgbmv.c
   cblas_cgemm.c
   cblas_cgemv.c
   cblas_cgerc.c
   cblas_cgeru.c
   #cblas_chbmv.c
   #cblas_chemm.c
   #cblas_chemv.c
   #cblas_cher2.c
   #cblas_cher2k.c
   #cblas_cher.c
   #cblas_cherk.c
   #cblas_chpmv.c
   #cblas_chpr2.c
   #cblas_chpr.c
   cblas_cscal.c
   #cblas_csscal.c
   #cblas_cswap.c
   #cblas_csymm.c
   #cblas_csyr2k.c
   #cblas_csyrk.c
   #cblas_ctbmv.c
   #cblas_ctbsv.c
   #cblas_ctpmv.c
   #cblas_ctpsv.c
   #cblas_ctrmm.c
   #cblas_ctrmv.c
   cblas_ctrsm.c
   #cblas_ctrsv.c
   #cblas_dasum.c
   cblas_daxpy.c
   #cblas_dcopy.c
   cblas_ddot.c
   #cblas_dgbmv.c
   cblas_dgemm.c
   cblas_dgemv.c
   cblas_dger.c
   #cblas_dnrm2.c
   #cblas_drot.c
   #cblas_drotg.c
   #cblas_drotm.c
   #cblas_drotmg.c
   #cblas_dsbmv.c
   cblas_dscal.c
   #cblas_dsdot.c
   #cblas_dspmv.c
   #cblas_dspr2.c
   #cblas_dspr.c
   #cblas_dswap.c
   #cblas_dsymm.c
   #cblas_dsymv.c
   #cblas_dsyr2.c
   #cblas_dsyr2k.c
   #cblas_dsyr.c
   #cblas_dsyrk.c
   #cblas_dtbmv.c
   #cblas_dtbsv.c
   #cblas_dtpmv.c
   #cblas_dtpsv.c
   #cblas_dtrmm.c
   #cblas_dtrmv.c
   cblas_dtrsm.c
   #cblas_dtrsv.c
   #cblas_dzasum.c
   #cblas_dznrm2.c
   #cblas_icamax.c
   #cblas_idamax.c
   #cblas_isamax.c
   #cblas_izamax.c
   #cblas_sasum.c
   cblas_saxpy.c
   #cblas_scasum.c
   #cblas_scnrm2.c
   #cblas_scopy.c
   cblas_sdot.c
   #cblas_sdsdot.c
   #cblas_sgbmv.c
   cblas_sgemm.c
   cblas_sgemv.c
   cblas_sger.c
   #cblas_snrm2.c
   #cblas_srot.c
   #cblas_srotg.c
   #cblas_srotm.c
   #cblas_srotmg.c
   #cblas_ssbmv.c
   cblas_sscal.c
   #cblas_sspmv.c
   #cblas_sspr2.c
   #cblas_sspr.c
   #cblas_sswap.c
   #cblas_ssymm.c
   #cblas_ssymv.c
   #cblas_ssyr2.c
   #cblas_ssyr2k.c
   #cblas_ssyr.c
   #cblas_ssyrk.c
   #cblas_stbmv.c
   #cblas_stbsv.c
   #cblas_stpmv.c
   #cblas_stpsv.c
   #cblas_strmm.c
   #cblas_strmv.c
   cblas_strsm.c
   #cblas_strsv.c
   cblas_xerbla.c
   cblas_zaxpy.c
   #cblas_zcopy.c
   cblas_zdotc_sub.c
   cblas_zdotu_sub.c
   #cblas_zdscal.c
   #cblas_zgbmv.c
   cblas_zgemm.c
   cblas_zgemv.c
   cblas_zgerc.c
   cblas_zgeru.c
   #cblas_zhbmv.c
   #cblas_zhemm.c
   #cblas_zhemv.c
   #cblas_zher2.c
   #cblas_zher2k.c
   #cblas_zher.c
   #cblas_zherk.c
   #cblas_zhpmv.c
   #cblas_zhpr2.c
   #cblas_zhpr.c
   cblas_zscal.c
   #cblas_zswap.c
   #cblas_zsymm.c
   #cblas_zsyr2k.c
   #cblas_zsyrk.c
   #cblas_ztbmv.c
   #cblas_ztbsv.c
   #cblas_ztpmv.c
   #cblas_ztpsv.c
   #cblas_ztrmm.c
   #cblas_ztrmv.c
   cblas_ztrsm.c
   #cblas_ztrsv.c

   cdotcsub.f
   cdotusub.f
   dasumsub.f
   ddotsub.f
   dnrm2sub.f
   dsdotsub.f
   dzasumsub.f
   dznrm2sub.f
   icamaxsub.f
   idamaxsub.f
   isamaxsub.f
   izamaxsub.f
   sasumsub.f
   scasumsub.f
   scnrm2sub.f
   sdotsub.f
   sdsdotsub.f
   snrm2sub.f
   zdotcsub.f
   zdotusub.f
      )

=== PKGBUILD ===
# Maintainer: Peter Budai <peterbudai@hotmail.com>

_realname=dlib
pkgbase="mingw-w64-${_realname}"
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}" "${MINGW_PACKAGE_PREFIX}-python-${_realname}")
pkgver=19.24.4
pkgrel=1
pkgdesc="A toolkit for making real world machine learning and data analysis applications in C++ (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
msys2_repository_url='https://github.com/davisking/dlib/'
msys2_references=(
  'pypi: dlib'
)
url='http://dlib.net/'
license=('spdx:BSL-1.0')
depends=("${MINGW_PACKAGE_PREFIX}-giflib"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-sqlite3")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-python-setuptools")
source=(${_realname}-${pkgver}.tar.gz::"https://github.com/davisking/${_realname}/archive/v${pkgver}.tar.gz"
        "001-python-binding.patch")
sha256sums=('d881911d68972d11563bb9db692b8fcea0ac1b3fd2e3f03fa0b94fde6c739e43'
            'b2f41b3a7663b29cf2141900508bc90bb21ad5d972eec190b1ffd3fd75aa0a9e')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  patch -Np1 -i "${srcdir}/001-python-binding.patch"

  cd "${srcdir}"
  cp -r "${_realname}-${pkgver}" "python-build-${MSYSTEM}"
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -G'Ninja' \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${_extra_config[@]}" \
      -DUSE_AVX_INSTRUCTIONS=ON \
      -DDLIB_ISO_CPP_ONLY=OFF \
      -DDLIB_IN_PROJECT_BUILD=OFF \
      -DDLIB_USE_CUDA=OFF \
      -DDLIB_JPEG_SUPPORT=ON \
      -DDLIB_PNG_SUPPORT=ON \
      -DDLIB_GIF_SUPPORT=ON \
      -DDLIB_LINK_WITH_SQLITE3=ON \
      -DDLIB_USE_FFTW=ON \
      -DBUILD_SHARED_LIBS=ON \
      -DBLA_VENDOR=OpenBLAS \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build .

  msg "Python build for ${MSYSTEM}"
  cd "${srcdir}/python-build-${MSYSTEM}"
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/python setup.py build \
    -G "Ninja" \
    --set CMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    --set USE_AVX_INSTRUCTIONS=ON \
    --set DLIB_ISO_CPP_ONLY=OFF \
    --set DLIB_IN_PROJECT_BUILD=ON \
    --set DLIB_USE_CUDA=OFF \
    --set DLIB_JPEG_SUPPORT=ON \
    --set DLIB_PNG_SUPPORT=ON \
    --set DLIB_GIF_SUPPORT=ON \
    --set DLIB_LINK_WITH_SQLITE3=ON \
    --set DLIB_USE_FFTW=ON \
    --set BLA_VENDOR=OpenBLAS=ON
}

#check() {
  #cd "${srcdir}"/build-${MSYSTEM}
  #make check
#}

package_dlib() {
  optdepends=("${MINGW_PACKAGE_PREFIX}-python-dlib")
  cd "${srcdir}"/build-${MSYSTEM}
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  # Remove hard coded library path from cmake files
  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})
  for pcfile in  "${pkgdir}${MINGW_PREFIX}"/lib/pkgconfig/*.pc; do
    sed -s "s|${PREFIX_DEPS}|${MINGW_PREFIX}|g" -i "${pcfile}"
  done
  pushd "${pkgdir}${MINGW_PREFIX}/lib/cmake/dlib" > /dev/null
  sed -s "s|${PREFIX_DEPS}/include||g" -i ./dlibConfig.cmake
  sed -s -e "s|${PREFIX_DEPS}/lib/||g" -e "s|${PREFIX_DEPS}/include||g" -i ./dlib.cmake
  popd > /dev/null
}

package_python-dlib() {
  depends=("${MINGW_PACKAGE_PREFIX}-dlib"
           "${MINGW_PACKAGE_PREFIX}-python")
  optdepends=("${MINGW_PACKAGE_PREFIX}-python-numpy: Python interface")
  provides=("${MINGW_PACKAGE_PREFIX}-python3-dlib")
  conflicts=("${MINGW_PACKAGE_PREFIX}-python3-dlib")
  replaces=("${MINGW_PACKAGE_PREFIX}-python3-dlib")

  cd "${srcdir}/python-build-${MSYSTEM}"
  MSYS2_ARG_CONV_EXCL="--prefix=;--install-scripts=;--install-platlib=" \
    ${MINGW_PREFIX}/bin/python setup.py install --prefix=${MINGW_PREFIX} --root="${pkgdir}" --optimize=1 --skip-build
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
